#!/bin/bash

_kaiming() {
  local pre cur opts
  COMPREPLY=()
  pre="${COMP_WORDS[COMP_CWORD-1]}"
  cur="${COMP_WORDS[COMP_CWORD]}"
	case $COMP_CWORD in 
	1)
    opts="install repair uninstall update list info enter export run ps kill search build build-init build-finish build-export --help --version -h -v "
    ;;	
	2)
		if [[ ${COMP_WORDS[1]} == "run" ]];then
       opts="$(find /opt/kaiming/layers -mindepth 4 -maxdepth 4 -type d \
                  -path '*/app/*' -o \
                  -path '*/base/*' -o \
                  -path '*/runtime/*' -o \
                  -path '*/extension/*' -o \
                  -path '*/depend/*' 2>/dev/null | \
                  xargs -I {} basename {} | sort | uniq) \
                  --help --verbose --devel --file-forwarding --command= -h -v -d"  
		fi
    if [[ ${COMP_WORDS[1]} == "uninstall" ]];then
        opts="$(find /opt/kaiming/layers -mindepth 4 -maxdepth 4 -type d \
                  -path '*/app/*' -o \
                  -path '*/base/*' -o \
                  -path '*/runtime/*' -o \
                  -path '*/extension/*' -o \
                  -path '*/depend/*' 2>/dev/null | \
                  xargs -I {} basename {} | sort | uniq ) \
                  --help --verbose --assumeyes --arch= --unused --delete-data -h -y -v"
    fi
    if [[ ${COMP_WORDS[1]} == "info" ]];then
         opts="$(find /opt/kaiming/layers -mindepth 4 -maxdepth 4 -type d \
                  -path '*/app/*' -o \
                  -path '*/base/*' -o \
                  -path '*/runtime/*' -o \
                  -path '*/extension/*' -o \
                  -path '*/depend/*' 2>/dev/null | \
                  xargs -I {} basename {} | sort | uniq ) \
                  --help --verbose -h -v"
    fi
    if [[ ${COMP_WORDS[1]} == "list" ]];then
        opts="--help --verbose --arch= --kind=  -h -v"
    fi
    if [[ ${COMP_WORDS[1]} == "enter" ]];then
         opts="--help -h"
    fi
    if [[ ${COMP_WORDS[1]} == "ps" ]];then
         opts="--help -h"
    fi
    if [[ ${COMP_WORDS[1]} == "kill" ]];then
         opts="--help -h"
    fi
    if [[ ${COMP_WORDS[1]} == "export" ]];then
         opts="$(find /opt/kaiming/layers -mindepth 4 -maxdepth 4 -type d \
              -path '*/app/*' -o \
              -path '*/base/*' -o \
              -path '*/runtime/*' -o \
              -path '*/extension/*' -o \
              -path '*/depend/*' 2>/dev/null | \
              xargs -I {} basename {} | sort | uniq ) \
              --help -y -v"
    fi
    if [[ ${COMP_WORDS[1]} == "build-init" ]];then
        opts="--help --arch= --runtime= --base --kind= --channel= -h"
    fi
    if [[ ${COMP_WORDS[1]} == "build" ]];then
         opts="--help --build-mount= --build-dir= --with-appdir --die-with-parent= --env= --unset-env= -h -p"
    fi
    if [[ ${COMP_WORDS[1]} == "build-finish" ]];then
         opts="--help --extra-data --env= --unset-env= -h"
    fi
    if [[ ${COMP_WORDS[1]} == "build-export" ]];then
         opts="--help --arch= --exclude --include -h"
    fi
    if [[ ${COMP_WORDS[1]} == "install" ]];then
        if [[ -f /opt/kaiming/packages ]]; then
          opts="$(cat /opt/kaiming/packages | sort | uniq | tr '\n' ' ') --help --verbose --assumeyes --arch= -h -y -v" 
        else
          opts="--help --verbose --assumeyes --arch= -h -y -v"
        fi
    fi
    if [[ ${COMP_WORDS[1]} == "repair" ]];then
        if [[ -f /opt/kaiming/packages ]]; then
          opts="$(cat /opt/kaiming/packages | sort | uniq | tr '\n' ' ') --help --verbose --assumeyes --arch= -h -y -v"
        else
          opts="--help --verbose --assumeyes --arch= -h -y -v"
        fi
    fi
    if [[ ${COMP_WORDS[1]} == "update" ]];then
        if [[ -f /opt/kaiming/packages ]]; then
          opts="$(cat /opt/kaiming/packages | sort | uniq | tr '\n' ' ') --help --verbose --assumeyes --arch= -h -y -v"
        else
          opts="--help --verbose --assumeyes --arch= -h -y -v"
        fi
    fi
    if [[ ${COMP_WORDS[1]} == "search" ]];then
        if [[ -f /opt/kaiming/packages ]]; then
          opts="$(cat /opt/kaiming/packages | sort | uniq | tr '\n' ' ') --help --verbose --assumeyes --arch= -h -v"
        else
          opts="--help --verbose --arch= -h -v"
        fi
    fi
    ;;
  3)
    if [[ "${COMP_WORDS[1]}" == "run" && "${COMP_WORDS[2]}" ]];  then
        opts="$(find /opt/kaiming/layers -mindepth 4 -maxdepth 4 -type d \
                -path '*/app/*' -o \
                -path '*/base/*' -o \
                -path '*/runtime/*' -o \
                -path '*/extension/*' -o \
                -path '*/depend/*' 2>/dev/null | \
                xargs -I {} basename {} | sort | uniq)"
    fi
    ;;
  4)
    if [[ "${COMP_WORDS[1]}" == "run" && "${COMP_WORDS[3]}" ]]; then
        opts="$(find /opt/kaiming/layers -mindepth 4 -maxdepth 4 -type d \
                -path '*/app/*' -o \
                -path '*/base/*' -o \
                -path '*/runtime/*' -o \
                -path '*/extension/*' -o \
                -path '*/depend/*' 2>/dev/null | \
                xargs -I {} basename {} | sort | uniq)"
    fi
    ;;
  5)
    if [[ "${COMP_WORDS[1]}" == "run" && "${COMP_WORDS[4]}" ]]; then
        opts="$(find /opt/kaiming/layers -mindepth 4 -maxdepth 4 -type d \
                -path '*/app/*' -o \
                -path '*/base/*' -o \
                -path '*/runtime/*' -o \
                -path '*/extension/*' -o \
                -path '*/depend/*' 2>/dev/null | \
                xargs -I {} basename {} | sort | uniq)"
    fi
  esac
  COMPREPLY=( $(compgen -W "${opts}" -- ${cur}) )
}

complete -F _kaiming kaiming


